/* ================================================================================
                                                                                  |
    Скрипты: Основные скрипты.                                                    |
    ----------------------------------------------------------------------------  |
                                                                                  |
    Предназначен для:                                                             |
        SantaGo = лендинг праздничных скидок в магазине:                          |
                      демо: http://demo.imperacms.ru/?theme=SantaGo               |
                      инфо: http://imperacms.ru/products/santago                  |
                      автор: EvenFly Team (http://evenfly.com)                    |
                             released under Creative Commons 3.0 license          |
                             (https://creativecommons.org/licenses/by/3.0/)       |
                                                                                  |
    ----------------------------------------------------------------------------  |
    Impera CMS - лёгкий и быстрый скрипт сайта с потрясающими возможностями.      |
    Мы создаём мощные решения с минимальным кодом и высокой скоростью загрузки.   |
                                                                                  |
================================================================================ */

    /* ============================================================================
    |                                                                             |
    |   Проверка что DOM-элемент имеет конкретный тип.                            |
    |                                                                             |
    |       element = проверяемый объект                                          |
    |       tagname = имя ожидаемого тега                                         |
    |       --------------------------------------------------------------------  |
    |       ВЫХОД = TRUE или FALSE если не имеет                                  |
    |                                                                             |
    ============================================================================ */

    function containsTag ( element, tagname ) {
        tagname = typeof tagname == 'string' ? tagname.toLowerCase()
                                             : '';
        return 'tagName' in element
             && element.tagName.toLowerCase() == tagname;
    };

    /* ============================================================================
    |                                                                             |
    |   Поиск ближайшего родителя конкретного типа.                               |
    |                                                                             |
    |       child = дочерний объект                                               |
    |       tagname = имя искомого тега                                           |
    |       --------------------------------------------------------------------  |
    |       ВЫХОД = объект родителя или NULL если не найден                       |
    |                                                                             |
    ============================================================================ */

    function closestParentTag ( child, tagname ) {
        while ('parentNode' in child) {
            if (child == document.body) break;
            child = child.parentNode;
            if (containsTag(child, tagname)) return child;
        }
        return null;
    };

    /* ============================================================================
    |                                                                             |
    |  Взять значение атрибута DOM-элемента.                                      |
    |                                                                             |
    |       element = проверяемый объект                                          |
    |       attr = имя искомого атрибута                                          |
    |       def = значение по умолчанию (если не указано, то равно пустой строке) |
    |       --------------------------------------------------------------------  |
    |       ВЫХОД = значение атрибута                                             |
    |                                                                             |
    ============================================================================ */

    function getElementAttribute ( element, attr, def ) {
        if (typeof def == 'undefined') def = '';
        if ('getAttribute' in element) {
            attr = element.getAttribute(attr);
            if (typeof attr != 'string') attr = def;
            return attr;
        }
        return def;
    };

    /* ============================================================================
    |                                                                             |
    |   Когда кликнули другой дизайн.                                             |
    |                                                                             |
    |       selectBox = список, где выбрали дизайн                                |
    |       --------------------------------------------------------------------  |
    |       ВЫХОД = TRUE                                                          |
    |                                                                             |
    ============================================================================ */

    function changeTheme ( selectBox ) {
        var box = selectBox.options[selectBox.selectedIndex],
            url = getElementAttribute(box, 'value');
        window.location.replace(url);
        return true;
    };

    /* ============================================================================
    |                                                                             |
    |   Клик по ссылке соцсети.                                                   |
    |                                                                             |
    ============================================================================ */

    function clickSocial ( anchor ) {
        var url = getElementAttribute(anchor, 'href');
        if (url == '') {
            var box = closestParentTag(anchor, 'li');
            url = getElementAttribute(box, 'data-href');
            if (url == '') return false;
            anchor.setAttribute('href', url);
        }
        return true;
    };

    /* ============================================================================
    |                                                                             |
    |   Custom Scrollbar.                                                         |
    |                                                                             |
    ============================================================================ */

    $(document).ready(
        function () {
            $("html").niceScroll({
                mousescrollstep: 70,
                cursorcolor: "#f53f2c",
                cursorwidth: "5px",
                cursorborderradius: "10px",
                cursorborder: "none",
            });
        }
    );

    /* ============================================================================
    |                                                                             |
    |   SmoothScroll.                                                             |
    |                                                                             |
    ============================================================================ */

    $(function () {
        $('a[href*=#]:not([href=#])').click(function () {
            if (location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') && location.hostname == this.hostname) {
                var target = $(this.hash);
                target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
                if (target.length) {
                    $('html,body').animate({
                        scrollTop: target.offset().top
                    }, 1000);
                    return false;
                }
            }
        });
    });
